 
#include <stdio.h>

extern int always_zero = 0;
static int *code_ptr;

void f(void)
{
/*
 * No static object declarations in this function ;-)
 */
if (always_zero == 1) /* create some dead code */
   {
   /*
    * Pad out with enough code to create storage for an int.
    * A smart optimizer is the last thing we need here.
    */
   always_zero++;
   always_zero++;
   }

(*code_ptr)++;
printf("This function has been called %d times.\n", *code_ptr);
}

void init(void)
{
/*
 * The value 16 is the offset of the dead code from the start of the
 * function.  Change to suit your local instruction sizes (this works
 * for gcc on an Intel x86).  We also need to make sure that the
 * pointer to int is correctly aligned.  A reliable guess is that
 * the alignment is a multiple of the object size.
 */
code_ptr=(int *)((((int)(char *)f) + 16) & ~(sizeof(int)-1));
*code_ptr=0;
}

int main(void)
{
init();
for (int index=0; index < 10; index++)
   f();
}
