 
#include <limits.h>

extern _Bool overflow;
extern int total;

void f(int next_digit_val)
{
/*
 * Check that the calculation will probably not overflow.  Perform
 * arithmetic on INT_MAX, but use a property (being a factor of
 * ten-less-than), not any specific numeric value.  The symbolic
 * name  is still being treated as the maximum representable int value.
 */
if (total < (INT_MAX / 10))
   total = (total * 10) + next_digit_val;
else
   overflow = 1;
}

unsigned int g(unsigned long some_val)
{
/*
 * While the internal representation of the value of UINT_MAX
 * is required to have all bits set, this might be considered
 * incidental to the property it is defined to represent.
 */
return (unsigned int)(some_val & UINT_MAX);
}

void h(int *characteristic)
{
/*
 * Comparing symbolic names against individual literal values is often
 * an indication that use is being made of representation details.  If
 * the comparisons occur together, as a set, it might be claimed that an
 * alternative representation of the characteristics of an implementation
 * are being deduced.  The usage below falls into the trap of overlooking
 * an undefined behavior (unless a translator has certain properties).
 */
switch (INT_MIN)
   {
   case -32767: *characteristic=1;
		break;

   case -32768: *characteristic=2;
		break;

   case -2147483647: *characteristic=3;
		break;

   default: *characteristic=4;
	    break;
   }
}
