 
/*
 * Declare a union containing all basic types and pointers to them.
 */
union align_u {
        char           c, *cp;
	short	       h, *hp;
        int            i, *ip;
        long           l, *lp;
        long long      ll, *llp;
        float          f, *fp;
        double         d, *dp;
        long double    ld, *ldp;
	void          *vp;
/*
 * Pointer-to function.  The standard does not define any generic
 * pointer types, like it does for pointer to void.  The wording<ref pointer to function, converted>
 * only requires the ability to convert.  There is no requirement
 * to be able to call the converted function pointer.
 */
        void         (*fv)(void);
        void         (*fo)();
        void         (*fe)(int, ...);
	};
/*
 * In the following structure type, the first member has type char.
 * The second member, a union type, will be aligned at least to the
 * strictest alignment of its contained types.  Assume that there
 * is no additional padding at the end of the structure declaration
 * than in the union.  Then we can calculate the strictest alignment
 * required by any object type (well at least those used to
 * define members of the union).
 */
struct align_s {
        char           c;
        union align_u  u;
	};
	
#define _ALIGN_  (sizeof(struct _align_s) - sizeof(union _align_u))
