 
/*
 * Some languages specify that the first two definitions of X are not
 * compatible, because the structure of their declarations is different.
 * Languages that do not expose the internal representation of a type
 * could regard the last definition of X as being compatible with the
 * previous two.  There are matching members and their types are the same.
 */
struct X {
          int a,
              b;
         };
struct X {
          int a;
          int b;
         };
struct X {
          int b;
          int a;
         };

/*
 * From the structural point of view the following
 * declarations are all different.
 */
extern unsigned int ui_1;
extern unsigned ui_2;
extern int unsigned ui_3;
