 
/**********************************************************
 * Allocate a local variable of the given size.           *
 * The offset depends on which way the system stack grows.*
 * (Although the offsets are always positive)             *
 *                                                        *
 *  If the stack is ascending, we need to                 *
 *     i. Align on the correct boundary                   *
 *    ii. The offset of the variable is the current offset*
 *   iii. Increment the offset to allow for this variable *
 *                                                        *
 *  If the stack is descending, we                        *
 *     i. Increment the current offset for this variable  *
 *    ii. Align on the correct boundary                   *
 *   iii. The offset of the variable is the current offset*
 *                                                        *
 * If the stack is descending, the offsets from the frame *
 * pointer (fp) are negative within the interpreter but   *
 * stored as positive offsets in mcc.  Thus aligning      *
 * upwards on mcc's offsets actually aligns downwards in  *
 * memory (which is what we require).                     *
 **********************************************************/
